import static java.util.Arrays.deepToString;
import static java.util.Arrays.fill;
import static java.util.Arrays.sort;

import java.io.*;
import java.util.*;

public class lcm_nn {

	static final int MAXN = 1000000000;
	static final int MAXK = 30;
	static final int MOD = 1000000007;

	static void solve() throws Exception {
		int n = nextInt();
//		assert 1 <= n && n <= MAXN;
		int k = nextInt();
//		assert 1 <= k && k <= MAXK;
        out.println(solve(n, k));
	}

	static int solve(int n, int k) {
		Factor[] f = factorize(n);
		int[] d = getDivisors(n);
		int[] maxPower = new int[f.length];
		for (int i = 0; i < f.length; i++) {
			int e = 1;
			for (int j = 0; j < f[i].pow; j++) {
				e *= f[i].prime;
			}
			maxPower[i] = e;
		}
		int[] mask = new int[d.length];
		for (int i = 0; i < d.length; i++) {
			for (int j = 0; j < f.length; j++) {
				if (d[i] % maxPower[j] == 0) {
					mask[i] |= 1 << j;
				}
			}
		}
		int[][] dp1 = new int[1 << f.length][d.length];
		int[][] dp2 = new int[1 << f.length][d.length];
		dp1[0][0] = 1;
		for (int currentK = 0; currentK <= k; currentK++) {
			for (int[] e : dp2) {
				fill(e, 0);
			}
			for (int i = 0; i < 1 << f.length; i++) {
				for (int j = 0; j < d.length; j++) {
					if (j + 1 < d.length) {
						dp1[i][j + 1] += dp1[i][j];
						if (dp1[i][j + 1] >= MOD) {
							dp1[i][j + 1] -= MOD;
						}
					}
					int newMask = i | mask[j];
					dp2[newMask][j] += dp1[i][j];
					if (dp2[newMask][j] >= MOD) {
						dp2[newMask][j] -= MOD;
					}
				}
			}
			{
				int[][] t = dp1;
				dp1 = dp2;
				dp2 = t;
			}
		}
		return (dp2[(1 << f.length) - 1][d.length - 1]);
	}

	static int[] getDivisors(int n) {
		List<Integer> d = new ArrayList<Integer>();
		for (long i = 1; i * i <= n; i++) {
			if (n % i != 0) {
				continue;
			}
			d.add((int) i);
			if (i * i != n) {
				d.add((int) (n / i));
			}
		}
		int[] ret = new int[d.size()];
		for (int i = 0; i < d.size(); i++) {
			ret[i] = d.get(i);
		}
		sort(ret);
		return ret;
	}

	static Factor[] factorize(int n) {
		List<Factor> ret = new ArrayList<Factor>();
		for (long i = 2; i * i <= n; i++) {
			if (n % i != 0) {
				continue;
			}
			int count = 0;
			while (n % i == 0) {
				count++;
				n /= i;
			}
			ret.add(new Factor((int) i, count));
		}
		if (n > 1) {
			ret.add(new Factor(n, 1));
		}
		return ret.toArray(new Factor[ret.size()]);
	}

	static class Factor {
		int prime;
		int pow;

		public Factor(int prime, int pow) {
			this.prime = prime;
			this.pow = pow;
		}

	}

	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;

	static void debug(Object... a) {
		System.err.println(deepToString(a));
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	static double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) {
		try {
			File file = new File("lcm.in");
			InputStream input = System.in;
			OutputStream output = System.out;
			if (file.canRead()) {
				input = (new FileInputStream(file));
				output = (new PrintStream("lcm.out"));
			}
			br = new BufferedReader(new InputStreamReader(input));
			out = new PrintWriter(output);
			solve();
			out.close();
			br.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}